\ job.fs -- myforth integrated development environment -- 14Sep13 rjn
\ 
true    constant tethered
true    constant turnkeyed
true    constant standalone

\ -----[ configure for 300 Dev ]
   $200  constant start        \ Reset vector.  Bootloader at $0000.
	$20B  constant TIM0         \ timer 0 interrupt
   $21B  constant TIM1         \ timer 1 overflow interrupt
   $223  constant RI           \ serial receive interrupt
   $22B  constant TIM2         \ timer 2 overflow interrupt
   $233  constant rom-start    \ start of code ($22b + $08)
   $1fff constant target-size  \ 8K flash, none reserved (?)
\ 
true constant cs?  \ produce compilation summary?
\ 
\ -----[ load MyForth system ]
\ 
$ff constant #dbuf  \ size of IPP data buffer
include mide-loader.fs
\ 
\ -----[ define SFRs, generate bootloader image ]
include sfr85x.fs
include bootloader850.fs 
\ 
\ version string is placed here by ver$
rom-start [ 20 + ] org  \ leave room for version string ver$
include serial.fs       \ serial I/O, strings
here rom-start org  -: ver$ string " MIDE 130928" ; org  \ version string
\ 
include 25_delays.fs    \ 25 MHz delays
include init.fs         \ chip initialization, I/O primitives
include utils.fs
\ 
\ -----[ Choose interpreter(s) ]
\ 
tethered   [if] include mide-tether.fs [then]
standalone [if] include mide-standalone.fs  [then]
\ 
\ -----[ load the application ] 
\ 
\ mide.txt                \ text link to doc file
include target_buffer.fs  \ Target download buffer and management
include hextools.fs       \ hex on target stack, display/send gforth hex
include ipp-stack.fs
include c2.fs             \ c2 protocol
include host-buffers.fs   \ read chip.bin, establish chip and image buffers
include commands.fs       \ help, etc.
include main.fs           \ initialization, go definition
\ include interactive.fs    \ Should come _after_ application for efficiency.
\ 
cs? [if] [ cr cr ] [then] 
\ 
\ -----[ patch the reset vector ]
turnkeyed [if]	\ Turnkeyed with go.
	start interrupt : cold stacks go ;      \ patch reset to go 
[else]	        \ Testing with quit.
	start interrupt : cold stacks quit ;
[then]
\ 
\ -----[ select interactive or standalone ]
tethered [if]  \ interactive number entry
	:m # tnumber emit-s m;
	:m ## [ dup 8 rshift $ff and swap $ff and ] # # m;
[then]  
\
standalone [if]  \ standalone - patch dictionary pointer
\ Note: see config.fs -- headers are tacked on (moved) to the end of code by "headers"
        : rst  cold ;
        headers ] here [ dict org heads ##p! org ]
        cs? [if] 
           [ .( heads start at: ) heads .  .(  size: ) ] 
		     here [ heads - .  .(  bytes) ]
        [then]
	here ( *) patch-cold org cold ( *) org  \ patch cold (after end of heads)
[then]
\
\ -----[ report build statistics ]
cs? [if] report [then]
save
[ .( Host stack= ) .s

